# Starter code for 15-462 mini-homework "Photonic Forensics"
# Run this code from the command line via
#
# python PhotonicForensics.py
#
import matplotlib.pyplot as plt
import numpy as np

# observed SML intensities of your own suit under colored lighting
s0 = 1.71234133
m0 = 15.03647706
l0 = 11.60313103

# observed SML intensities of the imposter's suit under colored lighting
sprime = 0.00820844624354783933
mprime = 0.48051216369101451553
lprime = 0.27889979029796052590

# the peak intensities of the red, green, and blue light curves
# occur at these indices of the R, G, B spectra, respectively
# (corresponding to the peak wavelengths lambda_r, lambda_g, lambda_b)
ir = 151
ig = 63
ib = 23

# Load all of the spectra from files -------------------------------------------

A = [] # your own suit's absorption spectrum
R = [] # red LED's emission spectrum
G = [] # green LED's emission spectrum
B = [] # blue LED's emission spectrum
S = [] # short cone response curve
M = [] # medium cone response curve
L = [] # long cone response curve

f = open("Absorption.txt", "r")
for line in f:
	A.append(float(line))

f = open("SCone.txt", "r")
for line in f:
	S.append(float(line))

f = open("MCone.txt", "r")
for line in f:
	M.append(float(line))

f = open("LCone.txt", "r")
for line in f:
	L.append(float(line))

f = open("RedEmission.txt", "r")
for line in f:
	R.append(float(line))

f = open("GreenEmission.txt", "r")
for line in f:
	G.append(float(line))

f = open("BlueEmission.txt", "r")
for line in f:
	B.append(float(line))

# Build up expression for observed SML values ----------------------------------

# initialize to zero
sr = 0
mr = 0
lr = 0

sg = 0
mg = 0
lg = 0

sb = 0
mb = 0
lb = 0

# TODO integrate over wavelengths
for i in range(len(A)):
	sr += # TODO
	mr += # TODO
	lr += # TODO

	sg += # TODO
	mg += # TODO
	lg += # TODO

	sb += # TODO
	mb += # TODO
	lb += # TODO

# Build matrix expression ------------------------------------------------------
s = np.array( [[sr], [sg], [sb]] )
m = np.array( [[mr], [mg], [mb]] )
l = np.array( [[lr], [lg], [lb]] )

U = # TODO build the matrix
b = # TODO build the vector

# Solve for light intensities --------------------------------------------------
x = # TODO solve for the light intensities
print "Intensity of red, green, blue lights (RGB):"
# TODO print it!

# Find the imposter's color! ---------------------------------------------------

# TODO figure out the color c

print "Impostor's color (RGB):"
# TODO print it!

